'*******************************************************************************
'
'  Copyright Michael Koecher aka six1 8/2010
'  -> http://www.six1.net/   michael@koecher-web.de
'
'   http://creativecommons.org/licenses/by-sa/3.0/de/
'
'   Sie drfen:
'
'     * das Werk bzw. den Inhalt vervielfltigen, verbreiten und ffentlich zugnglich machen
'
'     * Abwandlungen und Bearbeitungen des Werkes bzw. Inhaltes anfertigen
'
'   Zu Den Folgenden Bedingungen:
'
'     * Namensnennung.
'       Sie mssen den Namen des Autors/Rechteinhabers in der von ihm festgelegten Weise nennen.
'
'     * Keine kommerzielle Nutzung.
'       Dieses Werk darf nicht fr kommerzielle Zwecke verwendet werden.
'
'     * Weitergabe unter gleichen Bedingungen.
'       Wenn Sie das lizenzierte Werk bzw. den lizenzierten Inhalt bearbeiten
'       oder in anderer Weise erkennbar als Grundlage fr eigenes Schaffen verwenden,
'       drfen Sie die daraufhin neu entstandenen Werke bzw. Inhalte nur
'       unter Verwendung von Lizenzbedingungen weitergeben, die mit denen
'       dieses Lizenzvertrages identisch oder vergleichbar sind.
'
'   Wobei gilt:
'
'     * Verzichtserklrung
'       Jede der vorgenannten Bedingungen kann aufgehoben werden, sofern Sie
'       die ausdrckliche Einwilligung des Rechteinhabers dazu erhalten.
'
'     * Sonstige Rechte
'       Die Lizenz hat keinerlei Einfluss auf die folgenden Rechte:
'          - Die gesetzlichen Schranken des Urheberrechts und sonstigen
'            Befugnisse zur privaten Nutzung
'          - Das Urheberpersnlichkeitsrecht des Rechteinhabers
'          - Rechte anderer Personen, entweder am Lizenzgegenstand selber oder
'            bezglich seiner Verwendung, zum Beispiel Persnlichkeitsrechte abgebildeter Personen.
'
'  Hinweis
'
'      Im Falle einer Verbreitung mssen Sie anderen alle Lizenzbedingungen
'      mitteilen, die fr dieses Werk gelten. Am einfachsten ist es,
'      einen Link auf http://creativecommons.org/licenses/by-sa/3.0/de/ einzubinden.
'

'*******************************************************************************
$nocompile

'******************************************************************************
' W5300 Constants and variables
'******************************************************************************
   Const Wiz_stack_max = 8
   Const Wiz_mtu_size = 1460                                'default MTU

   Const Wiz_stack_timeout_value = 2                        ' in seconds

   Dim Wiz_stack_filepos(wiz_stack_max) As Xram Long
   Dim Wiz_stack_filesize(wiz_stack_max) As Xram Long
   Dim Wiz_stack_first_time(wiz_stack_max) As Xram Byte
   Dim Wiz_stack_timeout(wiz_stack_max) As Xram Byte
   Dim Wiz_stack_auth(wiz_stack_max) As Xram Byte
   Dim Wiz_stack_plainpass(wiz_stack_max) As Xram String * 30
   Dim Wiz_stack_filename(wiz_stack_max) As Xram String * 30
   Dim Wiz_stack_filepath(wiz_stack_max) As Xram String * 10
   Dim Wiz_stack_file_ext(wiz_stack_max) As Xram String * 3
   Dim Wiz_stack_cgi(wiz_stack_max) As Xram String * 40
   Dim Wiz_stack_replace_chars(wiz_stack_max) As Xram Byte


   Dim Days As Word
   Dim Calculate_days As Single

   Const Max_buf = 8192
   Dim W5300_payload_byte(max_buf) As Xram Byte
 '  Dim W5300_payload As Xram String * Max_buf At W5300_payload_byte Overlay


   Dim Adres32 As Long
   Dim Adres32_1 As Byte At Adres32 Overlay
   Dim Adres32_2 As Byte At Adres32 + 1 Overlay
   Dim Adres32_3 As Byte At Adres32 + 2 Overlay
   Dim Adres32_4 As Byte At Adres32 + 3 Overlay

   Dim Adres16 As Long
   Dim Adres16_l As Byte At Adres16 Overlay
   Dim Adres16_h As Byte At Adres16 + 1 Overlay

   Dim Tmp_port As Word
   Dim Tmp_port_l As Byte At Tmp_port Overlay
   Dim Tmp_port_h As Byte At Tmp_port + 1 Overlay


   Dim W5300_ip(4) As Byte
   Dim W5300_ip_l As Byte At W5300_ip Overlay
   Dim W5300_dhcp_ip(4) As Byte
   Dim W5300_gw(4) As Byte
   Dim W5300_mac(6) As Byte
   Dim W5300_mask(4) As Byte
   Dim W5300_dest_ip(4) As Byte
   Dim W5300_time_server(4) As Byte
   Dim W5300_port As Word
   Dim W5300_port_l As Byte At W5300_port Overlay
   Dim W5300_port_h As Byte At W5300_port + 1 Overlay
   Dim Wiz_hostname As String * 12

   Dim Running As Long
   Dim Wiz_time As Long
   Dim New_second As Byte


'-------------------------------------------------------------------------------
' Get_date give back Date with four digit year
'-------------------------------------------------------------------------------
Declare Function Get_date() As String
'-------------------------------------------------------------------------------
' Set W5300 common Registers an reset device
'-------------------------------------------------------------------------------
Declare Sub Wiz_init()
'-------------------------------------------------------------------------------
' Set Network Parameters
'-------------------------------------------------------------------------------
Declare Sub Wiz_set_network(byval Typ As Byte , Byref Address As Byte)
'-------------------------------------------------------------------------------
'   Close Socket
'-------------------------------------------------------------------------------
Declare Sub Socket_close(byval Socket_number As Byte)
'-------------------------------------------------------------------------------
'   Open Socket
'-------------------------------------------------------------------------------
Declare Sub Socket_open(byval Socket_number As Byte , Byval Protokoll As Byte , Byval Src_port As Word , Byval Dst_port As Word , Byref Dst_ip As Byte , Byval Modus As Byte)
'-------------------------------------------------------------------------------
'   Get Free Socket
'-------------------------------------------------------------------------------
Declare Function Get_free_socket() As Byte
'-------------------------------------------------------------------------------
'   Get Rx Size on Sock
'-------------------------------------------------------------------------------
Declare Function Get_rx_size(byval Socket_number As Byte) As Word
'-------------------------------------------------------------------------------
'   Get Tx Size on Sock
'-------------------------------------------------------------------------------
Declare Function Get_tx_size(byval Socket_number As Byte) As Word
'-------------------------------------------------------------------------------
'   Get Socket Status
'-------------------------------------------------------------------------------
Declare Function Get_socket_status(byval Socket_number As Byte) As Byte
'-------------------------------------------------------------------------------
'   Write Wiznet Base Register Adress Data
'-------------------------------------------------------------------------------
Declare Sub Wiz_write(byval Address_a As Word , Byval Data_a As Byte)
'-------------------------------------------------------------------------------
'   Read Wiznet Base Register Adress Data
'-------------------------------------------------------------------------------
Declare Function Wiz_read(byval A As Word) As Byte
'-------------------------------------------------------------------------------
'   Write Wiznet Socket Register Adress Data
'-------------------------------------------------------------------------------
Declare Sub Wiz_write_socket(byval Socket_number As Byte , Byval Register As Word , Byval Data_a As Byte)
'-------------------------------------------------------------------------------
'   Read Wiznet Socket Register Adress Data
'-------------------------------------------------------------------------------
Declare Function Wiz_read_socket(byval Socket_number As Byte , Byval Register As Word) As Byte
'-------------------------------------------------------------------------------
'  Fill Wiz Buff from peer Buff
'-------------------------------------------------------------------------------
Declare Sub Wiz_write_databuf(byval Socket_number As Byte , Byval Data_len As Word)       ', Byref From_buffer As Byte)
'-------------------------------------------------------------------------------
' wait while TX Buff is sended
'-------------------------------------------------------------------------------
Declare Sub Wiz_wait_tx(byval Socket_number As Byte)
'-------------------------------------------------------------------------------
' four bytes to long value
'-------------------------------------------------------------------------------
Declare Function Bytes2long(byval Byte_lowest As Byte , Byval Byte_low As Byte , Byval Byte_high As Byte , Byval Byte_highest As Byte) As Long
'-------------------------------------------------------------------------------
' Debug output of Sock Stats
'-------------------------------------------------------------------------------
Declare Sub Dump_socket_stats
'-------------------------------------------------------------------------------
'   Reset Sock Variables
'-------------------------------------------------------------------------------
Declare Sub Sock_stack_reset(byval Socket_number As Byte)
'-------------------------------------------------------------------------------
' for safty :-) we don't like hanging Sock'S
'-------------------------------------------------------------------------------
Declare Sub Check_timeout()
'-------------------------------------------------------------------------------
' Checkout RX on Socks
'-------------------------------------------------------------------------------
Declare Sub Wiz_rx