'*******************************************************************************
'
'  Copyright Michael Koecher aka six1 8/2010
'  -> http://www.six1.net/   michael@koecher-web.de
'
'   http://creativecommons.org/licenses/by-sa/3.0/de/
'
'   Sie drfen:
'
'     * das Werk bzw. den Inhalt vervielfltigen, verbreiten und ffentlich zugnglich machen
'
'     * Abwandlungen und Bearbeitungen des Werkes bzw. Inhaltes anfertigen
'
'   Zu Den Folgenden Bedingungen:
'
'     * Namensnennung.
'       Sie mssen den Namen des Autors/Rechteinhabers in der von ihm festgelegten Weise nennen.
'
'     * Keine kommerzielle Nutzung.
'       Dieses Werk darf nicht fr kommerzielle Zwecke verwendet werden.
'
'     * Weitergabe unter gleichen Bedingungen.
'       Wenn Sie das lizenzierte Werk bzw. den lizenzierten Inhalt bearbeiten
'       oder in anderer Weise erkennbar als Grundlage fr eigenes Schaffen verwenden,
'       drfen Sie die daraufhin neu entstandenen Werke bzw. Inhalte nur
'       unter Verwendung von Lizenzbedingungen weitergeben, die mit denen
'       dieses Lizenzvertrages identisch oder vergleichbar sind.
'
'   Wobei gilt:
'
'     * Verzichtserklrung
'       Jede der vorgenannten Bedingungen kann aufgehoben werden, sofern Sie
'       die ausdrckliche Einwilligung des Rechteinhabers dazu erhalten.
'
'     * Sonstige Rechte
'       Die Lizenz hat keinerlei Einfluss auf die folgenden Rechte:
'          - Die gesetzlichen Schranken des Urheberrechts und sonstigen
'            Befugnisse zur privaten Nutzung
'          - Das Urheberpersnlichkeitsrecht des Rechteinhabers
'          - Rechte anderer Personen, entweder am Lizenzgegenstand selber oder
'            bezglich seiner Verwendung, zum Beispiel Persnlichkeitsrechte abgebildeter Personen.
'
'  Hinweis
'
'      Im Falle einer Verbreitung mssen Sie anderen alle Lizenzbedingungen
'      mitteilen, die fr dieses Werk gelten. Am einfachsten ist es,
'      einen Link auf http://creativecommons.org/licenses/by-sa/3.0/de/ einzubinden.
'

'*******************************************************************************
$nocompile


Sub Show_lcd()
       'switch display every 2 seconds
       If _sec.0 = 1 Then
         Incr Lcd_count
         If Lcd_count > 7 Then Lcd_count = 1
         #if Wiz200_evb = 1
         Temperatur_single = Evb_get_temp()
         #endif
         Cls
         Locate 1 , 1
         Lcd "WIZ200"
         Select Case Lcd_count
          Case 1 :
            Locate 2 , 1
            Lcd "V"
            Locate 2 , 3
            Lcd Version(2)
          Case 2 :
            Locate 1 , 9 : If Ntp_on = 1 Then Lcd "NTP " : Lcd "Time"
            Locate 2 , 1
            Lcd Time(wiz_time)
          Case 3:
            Locate 1 , 9 : If Ntp_on = 1 Then Lcd "NTP " : Lcd "Date"
            Locate 2 , 1
            Lcd Get_date()
          Case 4:
            Locate 1 , 9 : Lcd "IP "
            If Dhcp_status = Dhcp_status_bound Then
              Lcd "DHCP"
            Else
              Lcd "STAT"
            End If
            Locate 2 , 1
            Lcd Wiz_read(w5300_sipr0 ) ; "." ; Wiz_read(w5300_sipr1 ) ; "." ; Wiz_read(w5300_sipr2 ) ; "." ; Wiz_read(w5300_sipr3 )
          Case 5:
            Locate 1 , 9 : Lcd "running"
            Locate 2 , 1
            Calculate_days = Running / 86400
            Days = Int(calculate_days)
            Lcd Days ; " Day " ; Time(running)
          Case 6:
            Locate 1 , 9 : Lcd "Request"
            Locate 2 , 1
            Lcd "Total Site: " ; Http_z_index
          Case 7:
            Locate 1 , 9 : Lcd "News"
            Locate 2 , 1
            Lcd Lcd_zeile_2
         End Select
       End If
End Sub
