'*******************************************************************************
'
'  Copyright Michael Koecher aka six1 8/2010
'  -> http://www.six1.net/   michael@koecher-web.de
'
'   http://creativecommons.org/licenses/by-sa/3.0/de/
'
'   Sie drfen:
'
'     * das Werk bzw. den Inhalt vervielfltigen, verbreiten und ffentlich zugnglich machen
'
'     * Abwandlungen und Bearbeitungen des Werkes bzw. Inhaltes anfertigen
'
'   Zu Den Folgenden Bedingungen:
'
'     * Namensnennung.
'       Sie mssen den Namen des Autors/Rechteinhabers in der von ihm festgelegten Weise nennen.
'
'     * Keine kommerzielle Nutzung.
'       Dieses Werk darf nicht fr kommerzielle Zwecke verwendet werden.
'
'     * Weitergabe unter gleichen Bedingungen.
'       Wenn Sie das lizenzierte Werk bzw. den lizenzierten Inhalt bearbeiten
'       oder in anderer Weise erkennbar als Grundlage fr eigenes Schaffen verwenden,
'       drfen Sie die daraufhin neu entstandenen Werke bzw. Inhalte nur
'       unter Verwendung von Lizenzbedingungen weitergeben, die mit denen
'       dieses Lizenzvertrages identisch oder vergleichbar sind.
'
'   Wobei gilt:
'
'     * Verzichtserklrung
'       Jede der vorgenannten Bedingungen kann aufgehoben werden, sofern Sie
'       die ausdrckliche Einwilligung des Rechteinhabers dazu erhalten.
'
'     * Sonstige Rechte
'       Die Lizenz hat keinerlei Einfluss auf die folgenden Rechte:
'          - Die gesetzlichen Schranken des Urheberrechts und sonstigen
'            Befugnisse zur privaten Nutzung
'          - Das Urheberpersnlichkeitsrecht des Rechteinhabers
'          - Rechte anderer Personen, entweder am Lizenzgegenstand selber oder
'            bezglich seiner Verwendung, zum Beispiel Persnlichkeitsrechte abgebildeter Personen.
'
'  Hinweis
'
'      Im Falle einer Verbreitung mssen Sie anderen alle Lizenzbedingungen
'      mitteilen, die fr dieses Werk gelten. Am einfachsten ist es,
'      einen Link auf http://creativecommons.org/licenses/by-sa/3.0/de/ einzubinden.
'

'*******************************************************************************
$nocompile

Const Dns_cache_size = 10

Dim Dns_cache_time(dns_cache_size) As Dword
Dim Dns_cache_url(dns_cache_size) As Xram String * 30
Dim Dns_cache_ip_oct1(dns_cache_size) As Xram Byte
Dim Dns_cache_ip_oct2(dns_cache_size) As Xram Byte
Dim Dns_cache_ip_oct3(dns_cache_size) As Xram Byte
Dim Dns_cache_ip_oct4(dns_cache_size) As Xram Byte
Dim Dns_resolved_ip(4) As Xram Byte



'-------------------------------------------------------------------------------
'  Udp_resolve_url_tx  Get IP from URL
'-------------------------------------------------------------------------------
Declare Function Dns_resolve_url(byval Socket_number As Byte , Byref Url As String) As Byte
'-------------------------------------------------------------------------------
'  Udp_resolve_url_rx  Got answer from DNS
'-------------------------------------------------------------------------------
Declare Function Dns_resolve_url_rx(byval Socket_number As Byte , Byref Url As String) As Byte
'-------------------------------------------------------------------------------
'  Dns_cache_check_for_url  Check, if URL already in cache
'-------------------------------------------------------------------------------
Declare Function Dns_cache_check_for_url(byref Url As String) As Byte
'-------------------------------------------------------------------------------
'  Dns_cache_get_insert_pos  Check for inserting position
'-------------------------------------------------------------------------------
Declare Function Dns_cache_get_insert_pos(byref Url As String) As Byte