'*******************************************************************************
'
'  Copyright Michael Koecher aka six1 8/2010
'  -> http://www.six1.net/   michael@koecher-web.de
'
'   http://creativecommons.org/licenses/by-sa/3.0/de/
'
'   Sie drfen:
'
'     * das Werk bzw. den Inhalt vervielfltigen, verbreiten und ffentlich zugnglich machen
'
'     * Abwandlungen und Bearbeitungen des Werkes bzw. Inhaltes anfertigen
'
'   Zu Den Folgenden Bedingungen:
'
'     * Namensnennung.
'       Sie mssen den Namen des Autors/Rechteinhabers in der von ihm festgelegten Weise nennen.
'
'     * Keine kommerzielle Nutzung.
'       Dieses Werk darf nicht fr kommerzielle Zwecke verwendet werden.
'
'     * Weitergabe unter gleichen Bedingungen.
'       Wenn Sie das lizenzierte Werk bzw. den lizenzierten Inhalt bearbeiten
'       oder in anderer Weise erkennbar als Grundlage fr eigenes Schaffen verwenden,
'       drfen Sie die daraufhin neu entstandenen Werke bzw. Inhalte nur
'       unter Verwendung von Lizenzbedingungen weitergeben, die mit denen
'       dieses Lizenzvertrages identisch oder vergleichbar sind.
'
'   Wobei gilt:
'
'     * Verzichtserklrung
'       Jede der vorgenannten Bedingungen kann aufgehoben werden, sofern Sie
'       die ausdrckliche Einwilligung des Rechteinhabers dazu erhalten.
'
'     * Sonstige Rechte
'       Die Lizenz hat keinerlei Einfluss auf die folgenden Rechte:
'          - Die gesetzlichen Schranken des Urheberrechts und sonstigen
'            Befugnisse zur privaten Nutzung
'          - Das Urheberpersnlichkeitsrecht des Rechteinhabers
'          - Rechte anderer Personen, entweder am Lizenzgegenstand selber oder
'            bezglich seiner Verwendung, zum Beispiel Persnlichkeitsrechte abgebildeter Personen.
'
'  Hinweis
'
'      Im Falle einer Verbreitung mssen Sie anderen alle Lizenzbedingungen
'      mitteilen, die fr dieses Werk gelten. Am einfachsten ist es,
'      einen Link auf http://creativecommons.org/licenses/by-sa/3.0/de/ einzubinden.
'

'*******************************************************************************
$nocompile



'-------------------------------------------------------------------------------
'  Udp_resolve_url_rx  Got answer from DNS
'-------------------------------------------------------------------------------
function DNS_resolve_url_rx(byval Socket_number As Byte , Byref Url As String) as byte
    Local Y As Word , Pos As Word , Found As Word , Insert_pos As Byte
    Udp_dns_port_local = 0
     ' C0 0C 00 01 xx xx xx xx 00 04
     ' Name (C0 0C),TYP-A (00 01), Class In (00 01), ttl (4 Byte),data len (00 04)
     Found = 0
     For Y = 16 To Udp_header_payload_len
       Pos = 0
       If Udp_payload(y) = $00 Then
         Pos = Y + 1
         If Udp_payload(pos) = $04 Then
            Incr Pos
            Exit For
         End If
       End If
    Next

    If Pos > 0 Then
      Insert_pos = Dns_cache_get_insert_pos(url)
      Dns_resolve_url_rx = Insert_pos
      Dns_cache_url(insert_pos) = Url
      Dns_cache_time(insert_pos) = Wiz_time
      Dns_cache_ip_oct1(insert_pos) = Udp_payload(pos) : Incr Pos
      Dns_cache_ip_oct2(insert_pos) = Udp_payload(pos) : Incr Pos
      Dns_cache_ip_oct3(insert_pos) = Udp_payload(pos) : Incr Pos
      Dns_cache_ip_oct4(insert_pos) = Udp_payload(pos)

      Dns_resolved_ip(1) = Dns_cache_ip_oct1(insert_pos)
      Dns_resolved_ip(2) = Dns_cache_ip_oct2(insert_pos)
      Dns_resolved_ip(3) = Dns_cache_ip_oct3(insert_pos)
      Dns_resolved_ip(4) = Dns_cache_ip_oct4(Insert_pos)
    Else
      Dns_resolve_url_rx = 0
    End If
    #if Udp_debug > 0
       Print #1 , "Resolved IP: " ; Dns_resolved_ip(1) ; "." ; Dns_resolved_ip(2) ; "." ; Dns_resolved_ip(3) ; "." ; Dns_resolved_ip(4)
    #endif
    Call Socket_close(socket_number)
End Function

'-------------------------------------------------------------------------------
'  Udp_resolve_url_tx  Get IP from URL
'-------------------------------------------------------------------------------
Function Dns_resolve_url(byval Socket_number As Byte , Byref Url As String) As Byte
      Local Pos As Word , Y As Byte , Label_len As Byte , Label_len_pos As Byte
      Local Char As String * 1
      Local Dns_timeout As Word                                                 'in ms
      Local Rx_size As Word , Sock_int As Byte
      local dns_pos as byte

      Dns_pos = Dns_cache_check_for_url(url)
      If Dns_pos > 0 Then
        Dns_resolve_url = Dns_pos
        Exit Function
      End If

      Dns_resolved_ip(1) = 0 : Dns_resolved_ip(2) = 0 : Dns_resolved_ip(3) = 0 : Dns_resolved_ip(4) = 0
      Udp_dns_port_local = 50000
      Udp_dns_port_local = Udp_dns_port_local + Rnd(15000)

      Pos = 1
      'transaction id
      Udp_payload(pos) = Rnd($ff) : Incr Pos
      Udp_payload(pos) = Rnd($ff) : Incr Pos
      ' flags Standard query = $1000
      Udp_payload(pos) = $01 : Incr Pos
      Udp_payload(pos) = $00 : Incr Pos
      ' Questions
      Udp_payload(pos) = $00 : Incr Pos
      Udp_payload(pos) = $01 : Incr Pos
      ' Answer RRs
      Udp_payload(pos) = $00 : Incr Pos
      Udp_payload(pos) = $00 : Incr Pos
      ' Authority RRs
      Udp_payload(pos) = $00 : Incr Pos
      Udp_payload(pos) = $00 : Incr Pos
      ' Additional RRs
      Udp_payload(pos) = $00 : Incr Pos
      Udp_payload(pos) = $00 : Incr Pos

      'first label len
      Udp_payload(pos) = $00
      Label_len_pos = Pos
      Incr Pos

      Label_len = 1
      For Y = 1 To Len(url)
         Char = Mid(url , Y , 1)
         If Char = "." Then
            Decr Label_len
            Udp_payload(label_len_pos) = Label_len
            Label_len_pos = Pos
            Label_len = 0
         End If
         Udp_payload(pos) = Asc(char)
         Incr Pos
         Incr Label_len
      Next
      ' last label len
      Decr Label_len
      Udp_payload(label_len_pos) = Label_len
      'length Zero Byte
      Udp_payload(pos) = $00 : Incr Pos
      'Request Type: $0001 => Host Adress
      Udp_payload(pos) = $00 : Incr Pos
      Udp_payload(pos) = $01 : Incr Pos
      'Class: IN $0001
      Udp_payload(pos) = $00 : Incr Pos
      Udp_payload(pos) = $01

      Call Socket_open(socket_number , Sn_mr_udp , Udp_dns_port_local , Udp_dns_port_remote , W5300_gw(1) , 0)
      ' copy buf into tx fifo
      Call Udp_write_databuf(socket_number , Pos)
      ' updata txbuf pointer, send data
      Call Wiz_write_socket(socket_number , W5300_s0_cr1 , Sn_cr_send)

      #if dns_debug > 0
        Print #1 , "DNS Resolve: " ; Url ; "  ";
      #endif

      Reset Watchdog

      Dns_timeout = 0
      Dns_resolve_url = 0
      Do
        Incr Dns_timeout
        Rx_size = Get_rx_size(socket_number)
        If Rx_size > 0 Then
            Call Udp_read_paket_header(socket_number)
            Call Udp_read_databuf(socket_number , Udp_header_payload_len)
            Dns_resolve_url = Dns_resolve_url_rx(socket_number , Url)
            Dns_timeout = &HFFFF
        End If
        Waitms 1
      Loop Until Dns_timeout >= 200
End Function

'-------------------------------------------------------------------------------
'  Dns_cache_check_for_url  Check, if URL already in cache
'-------------------------------------------------------------------------------
Function Dns_cache_check_for_url(byref Url As String) As Byte
   Local X As Byte

   Dns_cache_check_for_url = 0
   For X = 1 To Dns_cache_size
      If Dns_cache_url(x) = Url Then
         Dns_cache_check_for_url = X
         Dns_cache_time(x) = Wiz_time
         Exit For
      End If
   Next
End Function

'-------------------------------------------------------------------------------
'  Dns_cache_get_insert_pos  Check for inserting position
'-------------------------------------------------------------------------------
Function Dns_cache_get_insert_pos(byref Url As String) As Byte
   Local X As Byte
   local min_time as dword

   X = Dns_cache_check_for_url(url)
   If X > 0 Then
      Dns_cache_get_insert_pos = X
      Exit Function
   End If


   Min_time = Wiz_time

   Dns_cache_get_insert_pos = 1
   For X = 1 To Dns_cache_size
      If Dns_cache_time(x) = 0 Then
         Dns_cache_get_insert_pos = X
         Exit For
      End If
      If Dns_cache_time(x) < Min_time Then
         Dns_cache_get_insert_pos = X
         Min_time = Dns_cache_time(x)
      End If
   Next
End Function
