$nocompile
'
'Includefile for W5300

Const Socket_reg_base = &H200
Const Socket_reg_size = &H40
Const Reg_base = &H8000
Const Map_base = &H8000

'Mode register
Const W5300_mr = Reg_base
Const W5300_mr0 = W5300_mr
Const W5300_mr1 = W5300_mr + 1

'interrupt
Const W5300_ir = Reg_base + &H2
Const W5300_ir0 = W5300_ir
Const W5300_ir1 = W5300_ir + 1

Const W5300_imr = Reg_base + &H4
Const W5300_imr0 = W5300_imr
Const W5300_imr1 = W5300_imr + 1

'Source Hardware Address registers
Const W5300_shar0 = Reg_base + &H8
Const W5300_shar1 = W5300_shar0 + 1
Const W5300_shar2 = W5300_shar0 + 2
Const W5300_shar3 = W5300_shar0 + 3
Const W5300_shar4 = W5300_shar0 + 4
Const W5300_shar5 = W5300_shar0 + 5
'Gateway address registers
Const W5300_gar0 = Reg_base + &H10
Const W5300_gar1 = W5300_gar0 + 1
Const W5300_gar2 = W5300_gar0 + 2
Const W5300_gar3 = W5300_gar0 + 3
'Subnet mask Address registers
Const W5300_subr0 = Reg_base + &H14
Const W5300_subr1 = W5300_subr0 + 1
Const W5300_subr2 = W5300_subr0 + 2
Const W5300_subr3 = W5300_subr0 + 3

'Source IP Address registers
Const W5300_sipr0 = Reg_base + &H18
Const W5300_sipr1 = W5300_sipr0 + 1
Const W5300_sipr2 = W5300_sipr0 + 2
Const W5300_sipr3 = W5300_sipr0 + 3

'Transmit memory size of each SOCKET reigster
Const W5300_tms01r = Reg_base + &H20
Const W5300_tms23r = W5300_tms01r + 2
Const W5300_tms45r = W5300_tms01r + 4
Const W5300_tms67r = W5300_tms01r + 6

Const W5300_tmsr0 = W5300_tms01r
Const W5300_tmsr1 = W5300_tmsr0 + 1
Const W5300_tmsr2 = W5300_tmsr0 + 2
Const W5300_tmsr3 = W5300_tmsr0 + 3
Const W5300_tmsr4 = W5300_tmsr0 + 4
Const W5300_tmsr5 = W5300_tmsr0 + 5
Const W5300_tmsr6 = W5300_tmsr0 + 6
Const W5300_tmsr7 = W5300_tmsr0 + 7

'Transmit memory size of each SOCKET reigster
Const W5300_rms01r = Reg_base + &H28
Const W5300_rms23r = W5300_rms01r + 2
Const W5300_rms45r = W5300_rms01r + 4
Const W5300_rms67r = W5300_rms01r + 6

Const W5300_rmsr0 = W5300_rms01r
Const W5300_rmsr1 = W5300_rmsr0 + 1
Const W5300_rmsr2 = W5300_rmsr0 + 2
Const W5300_rmsr3 = W5300_rmsr0 + 3
Const W5300_rmsr4 = W5300_rmsr0 + 4
Const W5300_rmsr5 = W5300_rmsr0 + 5
Const W5300_rmsr6 = W5300_rmsr0 + 6
Const W5300_rmsr7 = W5300_rmsr0 + 7


'Memory type register
Const W5300_mtyper = Reg_base + &H30
Const W5300_mtyper0 = W5300_mtyper
Const W5300_mtyper1 = W5300_mtyper + 1

'PPPoe
Const W5300_patr = Reg_base + &H32
Const W5300_patr0 = W5300_patr
Const W5300_patr1 = W5300_patr + 1

'request timer
Const W5300_ptimer = Reg_base + &H36
Const W5300_ptimer0 = W5300_ptimer
Const W5300_ptimer1 = W5300_ptimer + 1

Const W5300_pmagicr = Reg_base + &H38
Const W5300_pmagicr0 = W5300_pmagicr
Const W5300_pmagicr1 = W5300_pmagicr + 1
                        '
Const W5300_uipr = Reg_base + &H48
Const W5300_uipr0 = W5300_uipr
Const W5300_uipr1 = W5300_uipr + 1
Const W5300_uipr2 = W5300_uipr + 2
Const W5300_uipr3 = W5300_uipr + 3


'Unreachable port number register
Const W5300_uportr = Reg_base + &H4C
Const W5300_uportr0 = W5300_uportr + 1
Const W5300_uportr1 = W5300_uportr + 2

'retry time
Const W5300_rtr = Reg_base + &H1C
Const W5300_rtr0 = W5300_rtr
Const W5300_rtr1 = W5300_rtr + 1

Const W5300_rcr = Reg_base + &H1E
Const W5300_rcr0 = W5300_rcr
Const W5300_rcr1 = W5300_rcr + 1

'***************************    SOCKET 0    ***************************


'Socket 0 registers
Const W5300_s0_mr = Reg_base + &H200
Const W5300_s0_mr0 = Reg_base + &H200
Const W5300_s0_mr1 = Reg_base + &H201


Const W5300_s0_cr = Reg_base + &H202
Const W5300_s0_cr0 = Reg_base + &H202
Const W5300_s0_cr1 = Reg_base + &H203

Const W5300_s0_imr = Reg_base + &H204
Const W5300_s0_imr0 = Reg_base + &H204
Const W5300_s0_imr1 = Reg_base + &H205

Const W5300_s0_ir = Reg_base + &H206
Const W5300_s0_ir0 = Reg_base + &H206
Const W5300_s0_ir1 = Reg_base + &H207

Const W5300_s0_ssr = Reg_base + &H208
Const W5300_s0_ssr0 = Reg_base + &H208
Const W5300_s0_ssr1 = Reg_base + &H209

'Socket 0 Source Port
Const W5300_s0_portr = Reg_base + &H20A
Const W5300_s0_portr0 = Reg_base + &H20A
Const W5300_s0_portr1 = Reg_base + &H20B

'Socket 0 Destination Hardware Address
Const W5300_s0_dhar = Reg_base + &H20C
Const W5300_s0_dhar0 = Reg_base + &H20C
Const W5300_s0_dhar1 = Reg_base + &H20D
Const W5300_s0_dhar2 = Reg_base + &H20E
Const W5300_s0_dhar3 = Reg_base + &H20F
Const W5300_s0_dhar4 = Reg_base + &H210
Const W5300_s0_dhar5 = Reg_base + &H211

'Socket 0 Destination Port Register
Const W5300_s0_dportr = Reg_base + &H212
Const W5300_s0_dportr0 = Reg_base + &H212
Const W5300_s0_dportr1 = Reg_base + &H213

'Socket 0 Destination IP Address
Const W5300_s0_dipr = Reg_base + &H214
Const W5300_s0_dipr0 = Reg_base + &H214
Const W5300_s0_dipr1 = Reg_base + &H215
Const W5300_s0_dipr2 = Reg_base + &H216
Const W5300_s0_dipr3 = Reg_base + &H217

'Socket 0 Maximum Segment Size
Const W5300_s0_mssr = Reg_base + &H218
Const W5300_s0_mssr0 = Reg_base + &H218                     'high
Const W5300_s0_mssr1 = Reg_base + &H219                     'low

'Socket 0 Protocol in IP Raw mode
Const W5300_s0_kpalvtr = Reg_base + &H21A
Const W5300_s0_protor = Reg_base + &H21B

'Socket 0 TOS register
Const W5300_s0_tosr = Reg_base + &H21C
Const W5300_s0_tosr0 = Reg_base + &H21C
Const W5300_s0_tosr1 = Reg_base + &H21D

'Socket 0 (Time to live) TTL register
Const W5300_s0_ttlr = Reg_base + &H21E
Const W5300_s0_ttlr0 = Reg_base + &H21E
Const W5300_s0_ttlr1 = Reg_base + &H21F

'Socket 0 Write Size Register
Const W5300_s0_tx_wrsr = Reg_base + &H220
Const W5300_s0_tx_wrsr0 = Reg_base + &H220
Const W5300_s0_tx_wrsr1 = Reg_base + &H221
Const W5300_s0_tx_wrsr2 = Reg_base + &H222
Const W5300_s0_tx_wrsr3 = Reg_base + &H223

'Socket 0 TX Free size
Const W5300_s0_tx_fs0 = Reg_base + &H224
Const W5300_s0_tx_fsr0 = Reg_base + &H224
Const W5300_s0_tx_fsr1 = Reg_base + &H225
Const W5300_s0_tx_fsr2 = Reg_base + &H226
Const W5300_s0_tx_fsr3 = Reg_base + &H227

'Socket 0 RX Received Size
Const W5300_s0_rx_rsr = Reg_base + &H228
Const W5300_s0_rx_rsr0 = Reg_base + &H228
Const W5300_s0_rx_rsr1 = Reg_base + &H229
Const W5300_s0_rx_rsr2 = Reg_base + &H22A
Const W5300_s0_rx_rsr3 = Reg_base + &H22B

'Socket 0 Fragment Register
Const W5300_s0_fragr = Reg_base + &H22C
Const W5300_s0_fragr0 = Reg_base + &H22C
Const W5300_s0_fragr1 = Reg_base + &H22D

'Socket 0 TX Fifo Register
Const W5300_s0_tx_fifor = Reg_base + &H22E
Const W5300_s0_tx_fifor0 = Reg_base + &H22E
Const W5300_s0_tx_fifor1 = Reg_base + &H22F

'Socket 0 RX Fifo Register
Const W5300_s0_rx_fifor = Reg_base + &H230
Const W5300_s0_rx_fifor0 = Reg_base + &H230
Const W5300_s0_rx_fifor1 = Reg_base + &H231

'--------------------------------------------------

' Sn_mr values
Const Sn_mr_close = &H00                                    ' unused socket
Const Sn_mr_tcp = &H01                                      ' TCP
Const Sn_mr_udp = &H02                                      ' UDP
Const Sn_mr_ipraw = &H03                                    ' IP LAYER RAW SOCK
Const Sn_mr_macraw = &H04                                   ' MAC LAYER RAW SOCK
Const Sn_mr_pppoe = &H05                                    ' PPPoE
Const Sn_mr_nd = &H20                                       ' No Delayed Ack(TCP) flag
Const Sn_mr_multi = &H80                                    ' support multicasting

Const Sn_mr0_align = 0                                      '&H00                                    ' header in dataload = 0

'Sn_cr values
Const Sn_cr_open = &H01                                     ' initialize or open socket
Const Sn_cr_listen = &H02                                   ' wait connection request in tcp mode(Server mode)
Const Sn_cr_connect = &H04                                  ' send connection request in tcp mode(Client mode)
Const Sn_cr_discon = &H08                                   ' send closing reqeuset in tcp mode
Const Sn_cr_close = &H10                                    ' close socket
Const Sn_cr_send = &H20                                     ' updata txbuf pointer, send data
Const Sn_cr_send_mac = &H21                                 ' send data with MAC address, so without ARP process
Const Sn_cr_send_keep = &H22                                ' send keep alive message
Const Sn_cr_recv = &H40                                     ' Update Rxbuf Pointer , Recv Data

'Sn_sr values
Const Sock_closed = &H00                                    ' closed

'Const Sock_arp &H01
Const Sock_init = &H13                                      ' init state
Const Sock_listen = &H14                                    ' listen state
Const Sock_synsent = &H15                                   ' Connection State
Const Sock_synrecv = &H16                                   ' connection state
Const Sock_established = &H17                               ' success to connect
Const Sock_fin_wait = &H18                                  ' closing state
Const Sock_closing = &H1A                                   ' closing state
Const Sock_time_wait = &H1B                                 ' closing state
Const Sock_close_wait = &H1C                                ' closing state
Const Sock_last_ack = &H1D                                  ' closing state
Const Sock_udp = &H22                                       ' udp socket
Const Sock_ipraw = &H32                                     ' ip raw mode socket
Const Sock_macraw = &H42                                    ' mac raw mode socket
Const Sock_pppoe = &H5F                                     ' Pppoe Socket Er , Recv Data

'Sn_ir Values
Const Sn_ir_con = 0                                         '$01
Const Sn_ir_discon = 1                                      '$02
Const Sn_ir_recv = 2                                        '$04
Const Sn_ir_timeout = 3                                     '$08

Const Sn_ir_sendok = 4                                      '$10
Const Sn_ir_pnext = 5                                       '$20
Const Sn_ir_pfail = 6                                       '$40
Const Sn_ir_precv = 7                                       '$80

'Master Register Values
Const Mr_ind = &H01
Const Mr_rst = &H80

Const Sock_0 = 0
Const Sock_1 = 1
Const Sock_2 = 2
Const Sock_3 = 3
Const Sock_4 = 4
Const Sock_5 = 5
Const Sock_6 = 6
Const Sock_7 = 7