'*******************************************************************************
'
'  Copyright Michael Koecher aka six1 8/2010
'  -> http://www.six1.net/   michael@koecher-web.de
'
'   http://creativecommons.org/licenses/by-sa/3.0/de/
'
'   Sie drfen:
'
'     * das Werk bzw. den Inhalt vervielfltigen, verbreiten und ffentlich zugnglich machen
'
'     * Abwandlungen und Bearbeitungen des Werkes bzw. Inhaltes anfertigen
'
'   Zu Den Folgenden Bedingungen:
'
'     * Namensnennung.
'       Sie mssen den Namen des Autors/Rechteinhabers in der von ihm festgelegten Weise nennen.
'
'     * Keine kommerzielle Nutzung.
'       Dieses Werk darf nicht fr kommerzielle Zwecke verwendet werden.
'
'     * Weitergabe unter gleichen Bedingungen.
'       Wenn Sie das lizenzierte Werk bzw. den lizenzierten Inhalt bearbeiten
'       oder in anderer Weise erkennbar als Grundlage fr eigenes Schaffen verwenden,
'       drfen Sie die daraufhin neu entstandenen Werke bzw. Inhalte nur
'       unter Verwendung von Lizenzbedingungen weitergeben, die mit denen
'       dieses Lizenzvertrages identisch oder vergleichbar sind.
'
'   Wobei gilt:
'
'     * Verzichtserklrung
'       Jede der vorgenannten Bedingungen kann aufgehoben werden, sofern Sie
'       die ausdrckliche Einwilligung des Rechteinhabers dazu erhalten.
'
'     * Sonstige Rechte
'       Die Lizenz hat keinerlei Einfluss auf die folgenden Rechte:
'          - Die gesetzlichen Schranken des Urheberrechts und sonstigen
'            Befugnisse zur privaten Nutzung
'          - Das Urheberpersnlichkeitsrecht des Rechteinhabers
'          - Rechte anderer Personen, entweder am Lizenzgegenstand selber oder
'            bezglich seiner Verwendung, zum Beispiel Persnlichkeitsrechte abgebildeter Personen.
'
'  Hinweis
'
'      Im Falle einer Verbreitung mssen Sie anderen alle Lizenzbedingungen
'      mitteilen, die fr dieses Werk gelten. Am einfachsten ist es,
'      einen Link auf http://creativecommons.org/licenses/by-sa/3.0/de/ einzubinden.
'

'*******************************************************************************
$nocompile


'******************************************************************************
' HTTP Constants and variables
'******************************************************************************
   Dim Http_z_index As Word
   ' File_read_pos must be a global variable!
   Dim File_read_pos As Long
   Dim Http_data_len As Word

   Http_z_index = 0

   Const Cr_lf = "{013}{010}"

'-------------------------------------------------------------------------------
' Http_parse work out of rx data, what's to do
'-------------------------------------------------------------------------------
Declare Sub Http_parse(byval Socket_number As Byte )
'-------------------------------------------------------------------------------
' Http_new_server Start new Webserver if one is in established Mode! (only if one is free!)
'-------------------------------------------------------------------------------
Declare Sub Http_new_server
'-------------------------------------------------------------------------------
' Http_send_block_from_sd_card Read data from sd-card and transfer to w5300 fifo
'-------------------------------------------------------------------------------
Declare Sub Http_send_block_from_sd_card(byval Socket_number As Byte )
'-------------------------------------------------------------------------------
' Read data from esf and transfer to w5300 fifo
'-------------------------------------------------------------------------------
Declare Sub Http_send_block_from_esf(byval Socket_number As Byte )
'-------------------------------------------------------------------------------
' Http_stack Check, if we must handle new data block on a Sock
'-------------------------------------------------------------------------------
Declare Sub Http_stack()
'-------------------------------------------------------------------------------
' Htp_first_time first call for a file? Translate a few things...
'-------------------------------------------------------------------------------
Declare Sub Http_first_time(byval Sock_count As Byte)
'-------------------------------------------------------------------------------
' Check_auth If htaccess file is in Directory, we have to check name and pass
'-------------------------------------------------------------------------------
Declare Sub Check_auth(byval Socket_number As Byte)
'-------------------------------------------------------------------------------
' Chg_dir change to different directory if needed
'-------------------------------------------------------------------------------
Declare Sub Chg_dir(byval Socket_number As Byte)
'-------------------------------------------------------------------------------
' Send_404_page  File not found answer
'-------------------------------------------------------------------------------
Declare Sub Send_404_page(byval Socket_number As Byte)
'-------------------------------------------------------------------------------
' Send_401_header we need authentication
'-------------------------------------------------------------------------------
Declare Sub Send_401_header(byval Socket_number As Byte)
'-------------------------------------------------------------------------------
' Http_read_file_from_sram Page content from Sram
'-------------------------------------------------------------------------------
Declare Sub Http_read_file_from_sram(byval Socket_number As Byte )
'-------------------------------------------------------------------------------
' Send_to_and_hold send data and hold connection
'-------------------------------------------------------------------------------
Declare Sub Send_to_and_hold(byval Socket_number As Byte)
'-------------------------------------------------------------------------------
' Send_to_and_hold send data and disconnect
'-------------------------------------------------------------------------------
Declare Sub Send_to_and_close(byval Socket_number As Byte)
'-------------------------------------------------------------------------------
' Http_check_value check for $ character on filename first and last char
'-------------------------------------------------------------------------------
Declare Function Http_check_value(byval Filename As String) As Byte
'-------------------------------------------------------------------------------
' Http_replace_chars replace content in file
'-------------------------------------------------------------------------------
Declare Sub Http_replace_chars(byval Max_len As Word)
'-------------------------------------------------------------------------------
' Find_char_pos find positio of a character in a file
'-------------------------------------------------------------------------------
Declare Function Find_char_pos(byval Startpos As Word , Byval Max_len As Word , Byval Charbyte As Byte) As Word
'-------------------------------------------------------------------------------
' Http_write_header send Header of following data
'-------------------------------------------------------------------------------
Declare Sub Http_write_header(byval Socket_number As Byte )
'-------------------------------------------------------------------------------
' Http_set_value spcial for cgi scripts
'-------------------------------------------------------------------------------
Declare Sub Http_set_value(byval Socket_number As Byte , Byval Filename As String , Byval Cgi_extension As String)
'-------------------------------------------------------------------------------
' Http_send_ajaxdyn dynamic content from ajax call
'-------------------------------------------------------------------------------
Declare Sub Http_send_ajaxdyn(byval Socket_number As Byte , Byval Filename As String)
'-------------------------------------------------------------------------------
' Http_send_javascript dynamic content fom javascript call
'-------------------------------------------------------------------------------
Declare Sub Http_send_javascript(byval Socket_number As Byte , Byval Filename As String)
'-------------------------------------------------------------------------------
' Http_dump_buffer  output dump of http Buffer
'-------------------------------------------------------------------------------
Declare Sub Http_dump_buffer(byval Art As Byte , Byval Data_len As Word )
'-------------------------------------------------------------------------------
' Http_parse_content  get value from Node
'-------------------------------------------------------------------------------
Declare Sub Http_parse_content(byref Node As String , Byref Cont_pos As Word , Byref Node_value As String , Byval Cut_char As String)

'-------------------------------------------------------------------------------
' SVG Graphics ;-)
'-------------------------------------------------------------------------------
Declare Function Svg_header(byref Dataload_pointer As Word , Byval Width As Word , Byval Height As Word) As Word
Declare Function Svg_line(byval X1 As Word , Byval Y1 As Word , Byval X2 As Word , Byval Y2 As Word , Byval Width As Byte , Byval Red As Byte , Byval Green As Byte , Byval Blue As Byte , Byval Dataload_pointer As Word)as Word
Declare Function Svg_end_path(byval Width As Byte , Byval Red As Byte , Byval Green As Byte , Byval Blue As Byte , Byval Dataload_pointer As Word) As Word
Declare Function Svg_begin_path(byval X1 As Word , Byval Y1 As Word , Byval Dataload_pointer As Word)as Word
Declare Sub Svg(byval Socket_number As Byte , Byval Filename As String)