'*******************************************************************************
'
'  Copyright Michael Koecher aka six1 8/2010
'  -> http://www.six1.net/   michael@koecher-web.de
'
'   http://creativecommons.org/licenses/by-sa/3.0/de/
'   Original nur von http://bascom-forum.de
'   Sie drfen:
'
'     * das Werk bzw. den Inhalt vervielfltigen, verbreiten und ffentlich zugnglich machen
'
'     * Abwandlungen und Bearbeitungen des Werkes bzw. Inhaltes anfertigen
'
'   Zu Den Folgenden Bedingungen:
'
'     * Namensnennung.
'       Sie mssen den Namen des Autors/Rechteinhabers in der von ihm festgelegten Weise nennen.
'
'     * Keine kommerzielle Nutzung.
'       Dieses Werk darf nicht fr kommerzielle Zwecke verwendet werden.
'
'     * Weitergabe unter gleichen Bedingungen.
'       Wenn Sie das lizenzierte Werk bzw. den lizenzierten Inhalt bearbeiten
'       oder in anderer Weise erkennbar als Grundlage fr eigenes Schaffen verwenden,
'       drfen Sie die daraufhin neu entstandenen Werke bzw. Inhalte nur
'       unter Verwendung von Lizenzbedingungen weitergeben, die mit denen
'       dieses Lizenzvertrages identisch oder vergleichbar sind.
'
'   Wobei gilt:
'
'     * Verzichtserklrung
'       Jede der vorgenannten Bedingungen kann aufgehoben werden, sofern Sie
'       die ausdrckliche Einwilligung des Rechteinhabers dazu erhalten.
'
'     * Sonstige Rechte
'       Die Lizenz hat keinerlei Einfluss auf die folgenden Rechte:
'          - Die gesetzlichen Schranken des Urheberrechts und sonstigen
'            Befugnisse zur privaten Nutzung
'          - Das Urheberpersnlichkeitsrecht des Rechteinhabers
'          - Rechte anderer Personen, entweder am Lizenzgegenstand selber oder
'            bezglich seiner Verwendung, zum Beispiel Persnlichkeitsrechte abgebildeter Personen.
'
'  Hinweis
'
'      Im Falle einer Verbreitung mssen Sie anderen alle Lizenzbedingungen
'      mitteilen, die fr dieses Werk gelten. Am einfachsten ist es,
'      einen Link auf http://creativecommons.org/licenses/by-sa/3.0/de/ einzubinden.
'

'*******************************************************************************

'-------------------------------------------------------------------------------
' ***WARNING***
'  ESF is set to 256 Byte Mode. THIS IS IRREVERSIBLE!
'  IF YOU DON'T LIKE THIS, DON'T USE THIS SOFTWARE!
'-------------------------------------------------------------------------------


'*** INSTALLATION HELP ***
' *** 1st Step ***
'1) compile and flash this File (change COM Port and USER SETUP to your preference)
'2) flash it on Micro and start it (...a few times!)
'   this is for setting ESF to 256 Byte Mode!!! before this is done, ESF functionality will not work!


' *** 2nd Step ***
'1) compile and flash "DualBootLoader_six1.bas" (change COM Port AND XTAL!!! to your preference)
'2) change OPTION/PROGRAMMER to MCS BOOTLOADER
'3) compile and flash this File (change COM Port and USER SETUP to your preference)
'4) now start WIZ200.exe, find WIZ200 and make settings
'5) have fun   /six1


   $regfile = "m128def.dat"


'-------------------------------------------------------------------------------
' @8MHz
   Const Reload = 31250                                     '= 1s
   $crystal = 8000000
'-------------------------------------------------------------------------------

'-------------------------------------------------------------------------------
' @12MHz
'   Const Reload = 46875                                                        '= 1s
'   $crystal = 12000000
'-------------------------------------------------------------------------------

'-------------------------------------------------------------------------------
' @16MHz
'   Const Reload = 62500                                     '= 1s
'   $crystal = 16000000
'-------------------------------------------------------------------------------

'-------------------------------------------------------------------------------
' SETUP SERIAL BAUDRATE for COM0 and COM1
'-------------------------------------------------------------------------------
   $baud = 38400                                            '38400
   $baud1 = 38400                                           ' 38400

'-------------------------------------------------------------------------------
' Setup Stack values
' with Stackcheck Option you can test the Usage of Stackvalues during run
'-------------------------------------------------------------------------------
   $hwstack = 150
   $swstack = 150
   $framesize = 800

   Const Show_stack = 0

   #if Show_stack = 1
   $lib "stackcheck.lib"
   $hwcheck                                                 'hw stack check on
   $framecheck
   $softcheck
   #endif

$version 3,3,3

'-------------------------------------------------------------------------------
' 32KB XRAM
'-------------------------------------------------------------------------------
   $xramstart = &H1100
   $xramsize = &H8000
   Config Xram = Enabled



'-------------------------------------------------------------------------------
' *** USER SETUP ***
'-------------------------------------------------------------------------------
   '---------------------------------------------------------------------------
   ' Debug Switches
   '---------------------------------------------------------------------------
      Const W5300_debug = 0
      Const Udp_debug = 0
      Const Debug_dhcp = 0
      Const Tcp_debug = 0
      Const Http_debug = 1
      Const Mysql_debug = 0
      Const Webradio_debug = 0
      Const Smtp_debug = 0
      Const Dns_debug = 0

   ' SOCKET NUMBERS MUST BE UNIQUE!

   '----------------------------------------------------------------------------
   ' Set Socks for Remote Setup usage    availible Socks 1 to 8
   ' Remote_sock MUST! be in Range of 1-8
   '----------------------------------------------------------------------------
      Const Remote_sock = 8

   '----------------------------------------------------------------------------
   ' Set Socks for NTP, DHCP, DNS usage    availible Socks 1 to 8 ;  0 = OFF
   ' Ntp_dhcp_dns Sock=0 --> Ntp_dhcp_dns isn't bound into Project!
   '----------------------------------------------------------------------------
      Const Ntp_dhcp_dns = 7

   '----------------------------------------------------------------------------
   ' Set Socks for MYSQL usage   /   availible Socks 1 to 8 ;  0 = OFF
   ' MYSQL Sock=0 --> MYSQL isn't bound into Project!
   '----------------------------------------------------------------------------
      Const Mysql_sock = 6

   '----------------------------------------------------------------------------
   ' Set Socks for smtp, SMTP usage    availible Socks 1 to 8 ;  0 = OFF
   ' smtp Sock=0 --> smtp isn't bound into Project!
   '----------------------------------------------------------------------------
      Const Smtp_sock = 0

   '----------------------------------------------------------------------------
   ' Usage of SD-Card or SRAM Files
   '----------------------------------------------------------------------------
   ' Read_file = 1 --> SRAM
   ' Read_file = 2 --> SD-Card
   ' Read_file = 3 --> ESF (ExternalSerialFlash)
      Const Read_file = 2

   '----------------------------------------------------------------------------
   ' SERIAL FOR DEBUG MESSAGES and BOOTLOADER
   '----------------------------------------------------------------------------
      Const Comport = 2

   '----------------------------------------------------------------------------
   ' LCD Do you use LCD? (WIZ200_LCD_Declarations.inc)
   '----------------------------------------------------------------------------
      Const Use_lcd = 1

   '----------------------------------------------------------------------------
   ' EVALUATIONS BOARD  Do you use WIZNET-EVB ?  (WIZNET200EVB_declarations.inc)
   '----------------------------------------------------------------------------
      Const Wiz200_evb = 1

   '----------------------------------------------------------------------------
   ' SD-Card Do you use SD-HC Card?
   '----------------------------------------------------------------------------
      Const Sd_hc = 1

'-------------------------------------------------------------------------------
' *** END OF USER SETUP ***
'-------------------------------------------------------------------------------








'-------------------------------------------------------------------------------
' Set Socks for Webserver usage
'-------------------------------------------------------------------------------
   Dim Webserver_socks As Byte , Socks_b As Byte

   Webserver_socks = &B1111_1111

   #if Ntp_dhcp_dns > 0
      Socks_b = Ntp_dhcp_dns
      Decr Socks_b
      Reset Webserver_socks.socks_b
   #endif
   #if Mysql_sock > 0
      Socks_b = Mysql_sock
      Decr Socks_b
      Reset Webserver_socks.socks_b
   #endif
   #if Remote_sock > 0
      Socks_b = Remote_sock
      Decr Socks_b
      Reset Webserver_socks.socks_b
   #endif
   #if Smtp_sock > 0
      Socks_b = Smtp_sock
      Decr Socks_b
      Reset Webserver_socks.socks_b
   #endif

'-------------------------------------------------------------------------------
' SERIAL FOR DEBUG MESSAGES and BOOTLOADER
'-------------------------------------------------------------------------------
   Dim Incoming_data As String * 22
   Incoming_data = ""
   #if Comport = 1
     Open "Com1:" For Binary As #1
     Config Serialin = Buffered , Size = 22 , Bytematch = 90       ' "Z"
     Declare Sub Serial0charmatch()
   #endif
   #if Comport = 2
     Open "Com2:" For Binary As #1
     Config Serialin1 = Buffered , Size = 22 , Bytematch = 90       ' "Z"
     Declare Sub Serial1charmatch()
   #endif


   Const Version_six = "WIZ200WEB V3.3 by six1"
   Print #1 , "V" ;
   Print #1 , Version(2)

'-------------------------------------------------------------------------------
' Include Declaration Files
' !!! have a look at WIZNET200EVB_declarations.inc for Hardware Setup !!!
'-------------------------------------------------------------------------------
   $include "w5300.inc"
   #if Wiz200_evb = 1
   $include "WIZNET200EVB_declarations.inc"
   #endif
   #if Use_lcd = 1
   $include "WIZ200_LCD_Declarations.inc"
   #endif
   $include "WIZ200_Hardware_Declarations.inc"
   $include "esf_declarations.inc"
   $include "W5300_eeram_declarations.inc"
   $include "W5300_declarations.inc"
   $include "wiz200_tcp_declarations.inc"
   $include "wiz200_udp_declarations.inc"
   $include "wiz200_dhcp_declarations.inc"
   $include "wiz200_http_declarations.inc"
   $include "wiz200_softclock_declarations.inc"
   $include "wiz200_sd-card_declarations.inc"
   #if Sd_hc = 1
    $include "Config_MMCSD_HC.bas"
   #else
    $include "Config_MMC.bas"
   #endif
   $include "CONFIG_AVR-DOS.bas"
   $include "dns_cache_declarations.inc"
   #if Ntp_dhcp_dns > 0
      $include "wiz200_ntp_declarations.inc"
   #endif
   #if Mysql_sock > 0
      $include "wiz200_mysql.inc"
   #endif
   #if Smtp_sock > 0
      $include "wiz200_smtp_declarations.inc"
   #endif




'-------------------------------------------------------------------------------
' Static Webserver Adresses (first time setup Network data via UDP remote setup!)
'-------------------------------------------------------------------------------
   Call Eeram_setup_network


   #if Use_lcd = 1
   Dim Lcd_count As Byte
   Cls
   Cursor Off
   Lcd "Init Wiz200..."
   #endif

'-------------------------------------------------------------------------------
' Initialize W5300 Registers and Reset W5300
'-------------------------------------------------------------------------------
   Call Wiz_init()

'-------------------------------------------------------------------------------
' Check for Watchdog Reset occurence and after init watchdog
'-------------------------------------------------------------------------------

   Dim Bwd As Byte
   Bwd = Peek(0)                                            ' read the wd flag
   If Bwd.wdrf = 1 Then                                     ' there was a WD overflow
      Print #1 , "Watchdog overflow occured!"
   End If

   Config Watchdog = 2048
   Start Watchdog
   Reset Watchdog

'-------------------------------------------------------------------------------
' Enable global Interrupts
'-------------------------------------------------------------------------------
   Enable Interrupts

'-------------------------------------------------------------------------------
' Init SD-Card, if used
'    Read_file = 1 --> SRAM
'    Read_file = 2 --> SD-Card
'    Read_file = 3 --> ESF (ExternalSerialFlash)
'-------------------------------------------------------------------------------
   #if Read_file = 2
      Call Sdcard_initialize()
   #endif

'-------------------------------------------------------------------------------
' Show Filelist in ESF if used  (ESF <> External Serial Flash)
'-------------------------------------------------------------------------------
   #if Read_file = 3
      Print #1 , "Filelist on ESF:"
      Call Esf_filelist
   #endif

'-------------------------------------------------------------------------------
' Declare Variables for Stack-Check
'-------------------------------------------------------------------------------
   #if Show_stack = 1
   Dim Stack_ww As Word , Stack_www As Word , Stack_wwww As Word
   #endif

'-------------------------------------------------------------------------------
'  just for demonstration: send one Mail
'-------------------------------------------------------------------------------
   #if Smtp_sock > 0
       Call Send_email(smtp_sock)
   #endif

'-------------------------------------------------------------------------------
' NTP Request will start in 3 seconds
'-------------------------------------------------------------------------------
   Ntp_request_time = Wiz_time + 3


'-------------------------------------------------------------------------------
'-------------------------------------------------------------------------------
' END OF INSTALLATION
'-------------------------------------------------------------------------------
'-------------------------------------------------------------------------------

'--- SAMPLE CODE FOR MYSQL ---

  'connect mysql
  Call Mysql_connect(mysql_sock)
  'change Database
  Query_str = "test"
  Call Mysql_sql_query(mysql_sock , Com_init_db , Query_str)
  'Select Data
  Query_str = "Select * from temp limit 250"
  Call Mysql_sql_query(mysql_sock , Com_query , Query_str )

  'disconnect mysql
'  Query_str = ""
'  Call Mysql_sql_query(mysql_sock , Com_close_db , Query_str)



'-------------------------------------------------------------------------------
'  Main Loop
'-------------------------------------------------------------------------------
Do
    If New_second = 1 Then
       New_second = 0

       #if Show_stack = 1
         Stack_ww = _hwstackstart - _hw_lowest
         Stack_www = _hwstack_low - _sw_lowest
         Stack_wwww = _frame_high - _fw_highest
         ' !!! Change const Value to defined $framesize !!!
         Stack_wwww = 800 - Stack_wwww
         Print #1 , "HW-SW-FS: " ; Stack_ww ; "-" ; Stack_www ; "-" ; Stack_wwww
       #endif

       'our Lifeguard for hanging Socks :-)
       Call Check_timeout()

       'Show Infos on LCD
       #if Use_lcd = 1
       Call Show_lcd
       #endif


       'Test mysql insert row
'(
       If _sec = 10 Then
            Query_str = "insert into temp (tempval, timestamp) values ('"
            #if Wiz200_evb = 1
              Temperatur_single = Evb_get_temp()
              Query_str = Query_str + Fusing(temperatur_single , "##.#")
            #else
              Query_str = Query_str + "'No Sensor"
            #endif
            Query_str = Query_str + "','"
            Mysql_concat_str = Mysql_get_datetime()
            Query_str = Query_str + Mysql_concat_str
            Query_str = Query_str + "')"
            Call Mysql_sql_query(mysql_sock , Com_query , Query_str)
       End If
')

       'NTP Time
       #if Smtp_sock > 0
       If Ntp_on = 1 And Smtp_flag = 0 Then
       #else
       If Ntp_on = 1 Then
       #endif
          If Ntp_request_time <= Wiz_time Then
             Print #1 , "NTP Request..."
             Ntp_request_time = Wiz_time + 3
             Call Ntp_request(ntp_dhcp_dns )
          End If
       End If

       ' DHCP Request
       #if Smtp_sock > 0
       If Dhcp_on = 1 And Smtp_flag = 0 Then
       #else
       If Dhcp_on = 1 Then
       #endif
          If Dhcp_request_time <= Wiz_time Then
             Print #1 , "DHCP Check Status"
             Dhcp_request_time = Wiz_time + 5
             Call Dhcp_every_minute(ntp_dhcp_dns)
          End If
       End If


    End If

    Reset Watchdog

    'do packet(block) sending
    Call Http_stack()

    'check for open Sock for Remote Config
    Call Check_udp_remote_config_sock(remote_sock)

    'something received?
    Call Wiz_rx()

    'Open new Web-Sock, if no listening port is available
    Call Http_new_server()

    'do packet(block) sending
    Call Http_stack()

Loop
End


  #if Comport = 1
  Sub Serial0charmatch()
   Input Incoming_data Noecho
   If Instr(incoming_data , "REBOOTWIZ") > 0 Then
      Goto &HF800
   End If
  End Sub
  #endif
  #if Comport = 2
  Sub Serial1charmatch()
   Input Incoming_data Noecho
   If Instr(incoming_data , "REBOOTWIZ") > 0 Then
      Goto &HF800
   End If
  End Sub
  #endif

   #if Wiz200_evb = 1
   $include "WIZNET200EVB_routines.inc"
   #endif
   #if Use_lcd = 1
   $include "WIZ200_LCD_Routines.inc"
   #endif
   $include "WIZ200_Hardware_Routines.inc"
   $include "esf_routines.inc"
   $include "W5300_eeram_routines.inc"
   $include "W5300_routines.inc"
   $include "wiz200_tcp_routines.inc"
   $include "wiz200_udp_routines.inc"
   $include "wiz200_dhcp_routines.inc"
   $include "wiz200_http_routines.inc"
   $include "wiz200_softclock_routines.inc"
   $include "wiz200_sd-card_routines.inc"
   $include "dns_cache_routines.inc"
   #if Ntp_dhcp_dns > 0
      $include "wiz200_ntp_routines.inc"
   #endif
   #if Smtp_sock > 0
      $include "wiz200_smtp_routines.inc"
   #endif



' **** ACHTUNG SVG MIT IE8 ****
' fr IE8 laden: http://www.ieaddons.com/en/details/Time_Savers/Adobe_SVG_Viewer/
' ALS ADMIN INSTALLIEREN!!!


#if Read_file = 1
$inc Index , Size , "html\index.htm"
$inc Logo , Size , "html\logo.jpg"
#endif
$inc 404 , Size , "html\404.htm"
$inc 401 , Size , "html\401.htm"
$inc Favicon , Size , "html\favicon.ico"

#if Smtp_sock > 0
Get_day_str:
Data "Mon" , "Tue" , "Wed" , "Thu" , "Fri" , "Sat" , "Sun"

Get_month_str:
Data "" , "Jan" , "Feb" , "Mar" , "Apr" , "May" , "Jun" , "Jul" , "Aug" , "Sep" , "Oct" , "Nov" , "Dec"
#endif