'*******************************************************************************
'
'  Copyright Michael Koecher aka six1 8/2010
'  -> http://www.six1.net/   michael@koecher-web.de
'
'   http://creativecommons.org/licenses/by-sa/3.0/de/
'
'   Sie drfen:
'
'     * das Werk bzw. den Inhalt vervielfltigen, verbreiten und ffentlich zugnglich machen
'
'     * Abwandlungen und Bearbeitungen des Werkes bzw. Inhaltes anfertigen
'
'   Zu Den Folgenden Bedingungen:
'
'     * Namensnennung.
'       Sie mssen den Namen des Autors/Rechteinhabers in der von ihm festgelegten Weise nennen.
'
'     * Keine kommerzielle Nutzung.
'       Dieses Werk darf nicht fr kommerzielle Zwecke verwendet werden.
'
'     * Weitergabe unter gleichen Bedingungen.
'       Wenn Sie das lizenzierte Werk bzw. den lizenzierten Inhalt bearbeiten
'       oder in anderer Weise erkennbar als Grundlage fr eigenes Schaffen verwenden,
'       drfen Sie die daraufhin neu entstandenen Werke bzw. Inhalte nur
'       unter Verwendung von Lizenzbedingungen weitergeben, die mit denen
'       dieses Lizenzvertrages identisch oder vergleichbar sind.
'
'   Wobei gilt:
'
'     * Verzichtserklrung
'       Jede der vorgenannten Bedingungen kann aufgehoben werden, sofern Sie
'       die ausdrckliche Einwilligung des Rechteinhabers dazu erhalten.
'
'     * Sonstige Rechte
'       Die Lizenz hat keinerlei Einfluss auf die folgenden Rechte:
'          - Die gesetzlichen Schranken des Urheberrechts und sonstigen
'            Befugnisse zur privaten Nutzung
'          - Das Urheberpersnlichkeitsrecht des Rechteinhabers
'          - Rechte anderer Personen, entweder am Lizenzgegenstand selber oder
'            bezglich seiner Verwendung, zum Beispiel Persnlichkeitsrechte abgebildeter Personen.
'
'  Hinweis
'
'      Im Falle einer Verbreitung mssen Sie anderen alle Lizenzbedingungen
'      mitteilen, die fr dieses Werk gelten. Am einfachsten ist es,
'      einen Link auf http://creativecommons.org/licenses/by-sa/3.0/de/ einzubinden.
'

'*******************************************************************************
$nocompile


' Dataflash Opcodes
'Const Flashpageread = &HD2                                                      ' Main Memory Page Read
Const Flashtobuf1transfer = &H53                                                ' Main Memory Page To Buffer 1 Transfer
Const Buf1read = &HD4                                                           ' Buffer 1 Read
Const Flashtobuf2transfer = &H55                                                ' Main Memory Page To Buffer 2 Transfer
Const Buf2read = &HD6                                                           ' Buffer 2 Read
Const Statusreg = &HD7                                                          '&H57                                                          ' Status Register
Const Autopagerewrbuf1 = &H58                                                   ' Auto Page Rewrite Through Buffer 1
Const Autopagerewrbuf2 = &H59                                                   ' Auto Page Rewrite Through Buffer 2
Const Flashtobuf1compare = &H60                                                 ' Main Memory Page To Buffer 1 Compare
Const Flashtobuf2compare = &H61                                                 ' Main Memory Page To Buffer 2 Compare
Const Contarrayread = &H68                                                      ' Continuous Array Read(note : Only A / B -parts Supported)
Const Flashprogbuf1 = &H82                                                      ' Main Memory Page Program Through Buffer 1
Const Buf1toflashwe = &H83                                                      ' Buffer 1 To Main Memory Page Program With Built -in Erase
Const Buf1write = &H84                                                          ' Buffer 1 Write
Const Flashprogbuf2 = &H85                                                      ' Main Memory Page Program Through Buffer 2
Const Buf2toflashwe = &H86                                                      ' Buffer 2 To Main Memory Page Program With Built -in Erase
Const Buf2write = &H87                                                          ' Buffer 2 Write
Const Buf1toflash = &H88                                                        ' Buffer 1 To Main Memory Page Program Without Built -in Erase
Const Buf2toflash = &H89                                                        ' Buffer 2 To Main Memory Page Program Without Built -in Erase

Dim Pagebits As Byte
Dim Pagesize As Word
Dim Status_register_value As Byte
Dim Pagecounter As Word
Dim Esfsystemsize As dword
Dim Esfsystemcount As dword
Dim Esfblockcount As Word
Dim Esfblockcount_old As Word

Dim Esf_file_start As Dword
Dim Esf_file_len As Word

Declare Function Df_read_status()as Byte
Declare Sub Df_init()
Declare Function Df_bufferreadbyte(byval Bufferno As Byte , Byval Intpageadr As Word) As Byte
Declare Sub Df_bufferwritebyte(byval Bufferno As Byte , Byval Intpageadr As Word , Byval Databyte As Byte)
Declare Sub Df_pagetobuffer(byval Bufferno As Byte , Byval Pageadr As Word)
Declare Sub Df_buffertopage(byval Bufferno As Byte , Byval Pageadr As Word)
Declare Sub Df_bufferreadarray(byval Bufferno As Byte , Byval Intpageadr As Word , Byval No_of_bytes As Word , Byref Bufferptr As Word)
Declare Sub Df_bufferwriteenable(byval Bufferno As Byte , Byval Intpageadr As Word)
Declare Sub Df_bufferwritestr(byval Bufferno As Byte , Byval Intpageadr As Word , Byval No_of_bytes As Word , Byref Bufferptr As Word)
Declare Sub Cont_flash_read_enable(byval Pageadr As Word , Byval Intpageadr As Word)
Declare Sub Df_chip_erase()
Declare Sub Esf_filelist()
Declare Sub ESF_check_pagepos(byref Pagepos As Word , Byref Page As Word)
declare function Esf_find_file(byval searchfile as string) as byte

Call Df_init()