'*******************************************************************************
'
'  Copyright Michael Koecher aka six1 8/2010
'  -> http://www.six1.net/   michael@koecher-web.de
'
'   http://creativecommons.org/licenses/by-sa/3.0/de/
'
'   Sie drfen:
'
'     * das Werk bzw. den Inhalt vervielfltigen, verbreiten und ffentlich zugnglich machen
'
'     * Abwandlungen und Bearbeitungen des Werkes bzw. Inhaltes anfertigen
'
'   Zu Den Folgenden Bedingungen:
'
'     * Namensnennung.
'       Sie mssen den Namen des Autors/Rechteinhabers in der von ihm festgelegten Weise nennen.
'
'     * Keine kommerzielle Nutzung.
'       Dieses Werk darf nicht fr kommerzielle Zwecke verwendet werden.
'
'     * Weitergabe unter gleichen Bedingungen.
'       Wenn Sie das lizenzierte Werk bzw. den lizenzierten Inhalt bearbeiten
'       oder in anderer Weise erkennbar als Grundlage fr eigenes Schaffen verwenden,
'       drfen Sie die daraufhin neu entstandenen Werke bzw. Inhalte nur
'       unter Verwendung von Lizenzbedingungen weitergeben, die mit denen
'       dieses Lizenzvertrages identisch oder vergleichbar sind.
'
'   Wobei gilt:
'
'     * Verzichtserklrung
'       Jede der vorgenannten Bedingungen kann aufgehoben werden, sofern Sie
'       die ausdrckliche Einwilligung des Rechteinhabers dazu erhalten.
'
'     * Sonstige Rechte
'       Die Lizenz hat keinerlei Einfluss auf die folgenden Rechte:
'          - Die gesetzlichen Schranken des Urheberrechts und sonstigen
'            Befugnisse zur privaten Nutzung
'          - Das Urheberpersnlichkeitsrecht des Rechteinhabers
'          - Rechte anderer Personen, entweder am Lizenzgegenstand selber oder
'            bezglich seiner Verwendung, zum Beispiel Persnlichkeitsrechte abgebildeter Personen.
'
'  Hinweis
'
'      Im Falle einer Verbreitung mssen Sie anderen alle Lizenzbedingungen
'      mitteilen, die fr dieses Werk gelten. Am einfachsten ist es,
'      einen Link auf http://creativecommons.org/licenses/by-sa/3.0/de/ einzubinden.
'

'*******************************************************************************
$nocompile

'******************************************************************************
' NTP frame
'******************************************************************************
Dim Ntp_msg(max_buf) As Xram Byte At W5300_payload_byte Overlay
Dim Ntp_b_peer_clock_stratum As Xram Byte At Ntp_msg + 1 Overlay
Dim Ntp_b_peer_polling_interval As Xram Byte At Ntp_msg + 2 Overlay
Dim Ntp_b_peer_clock_precision As Xram Byte At Ntp_msg + 3 Overlay
Dim Ntp_l_root_delay As Xram Long At Ntp_msg + 4 Overlay
Dim Ntp_l_root_dispersion As Xram Long At Ntp_msg + 8 Overlay
Dim Ntp_b4_ref_clock_id(4) As Xram Byte At Ntp_msg + 12 Overlay
Dim Ntp_b8_ref_clock_update_time(8) As Xram Byte At Ntp_msg + 16 Overlay
Dim Ntp_b8_originate_timestamp(8) As Xram Byte At Ntp_msg + 24 Overlay
Dim Ntp_b8_receive_timestamp(8) As Xram Byte At Ntp_msg + 32 Overlay
Dim Ntp_b8_transmit_timestamp(8) As Xram Byte At Ntp_msg + 40 Overlay

'******************************************************************************
' NTP Constants and variables
'******************************************************************************
Const Ntp_offset_to_bascom = 1139293696
Const Ntp_one_hour_offset = 3600
Const Ntp_flags_leap_indicator = 1
Const Ntp_flags_version = 3
Const Ntp_flags_mode = 3
Const Ntp_flags_server_gw = 42

Dim Ntp_on As Byte
Dim Ntp_stat_on As Byte
Dim Ntp_request_time As Dword
Ntp_request_time = 0

'-------------------------------------------------------------------------------
' Udp_ntp get time from received packet
'-------------------------------------------------------------------------------
Declare Sub Udp_ntp(byval Socket_number As Byte)
'-------------------------------------------------------------------------------
' Ntp_dst_correction correct date
'-------------------------------------------------------------------------------
Declare Sub Ntp_dst_correction
'-------------------------------------------------------------------------------
' Start An Ntp Request
'-------------------------------------------------------------------------------
Declare Sub Ntp_request(byval Socket_number As Byte)