'*******************************************************************************
'
'  Copyright Michael Koecher aka six1 8/2010
'  -> http://www.six1.net/   michael@koecher-web.de
'
'   http://creativecommons.org/licenses/by-sa/3.0/de/
'
'   Sie drfen:
'
'     * das Werk bzw. den Inhalt vervielfltigen, verbreiten und ffentlich zugnglich machen
'
'     * Abwandlungen und Bearbeitungen des Werkes bzw. Inhaltes anfertigen
'
'   Zu Den Folgenden Bedingungen:
'
'     * Namensnennung.
'       Sie mssen den Namen des Autors/Rechteinhabers in der von ihm festgelegten Weise nennen.
'
'     * Keine kommerzielle Nutzung.
'       Dieses Werk darf nicht fr kommerzielle Zwecke verwendet werden.
'
'     * Weitergabe unter gleichen Bedingungen.
'       Wenn Sie das lizenzierte Werk bzw. den lizenzierten Inhalt bearbeiten
'       oder in anderer Weise erkennbar als Grundlage fr eigenes Schaffen verwenden,
'       drfen Sie die daraufhin neu entstandenen Werke bzw. Inhalte nur
'       unter Verwendung von Lizenzbedingungen weitergeben, die mit denen
'       dieses Lizenzvertrages identisch oder vergleichbar sind.
'
'   Wobei gilt:
'
'     * Verzichtserklrung
'       Jede der vorgenannten Bedingungen kann aufgehoben werden, sofern Sie
'       die ausdrckliche Einwilligung des Rechteinhabers dazu erhalten.
'
'     * Sonstige Rechte
'       Die Lizenz hat keinerlei Einfluss auf die folgenden Rechte:
'          - Die gesetzlichen Schranken des Urheberrechts und sonstigen
'            Befugnisse zur privaten Nutzung
'          - Das Urheberpersnlichkeitsrecht des Rechteinhabers
'          - Rechte anderer Personen, entweder am Lizenzgegenstand selber oder
'            bezglich seiner Verwendung, zum Beispiel Persnlichkeitsrechte abgebildeter Personen.
'
'  Hinweis
'
'      Im Falle einer Verbreitung mssen Sie anderen alle Lizenzbedingungen
'      mitteilen, die fr dieses Werk gelten. Am einfachsten ist es,
'      einen Link auf http://creativecommons.org/licenses/by-sa/3.0/de/ einzubinden.
'

'*******************************************************************************$nocompile

Sub Activate_sdcard
    Call Deactivate_all_spi_units
    Reset Mmc_cs
End Sub


Sub Sdcard_initialize
    Call Sdcard_init_filesystem
    If Btemp1 <> 0 Or Gbdriveerror <> 0 Then
         Print #1 , "!!! Neustart !!!"
         Wait 1
        Goto 0
    End If
End Sub

Sub Sdcard_init_filesystem
   Call Activate_sdcard
   Print #1 , "-> Bind SD-Card -> ";
   If Gbdriveerror = 0 Then                                 '
      Print #1 , "Status OK"
      Btemp1 = Initfilesystem(1)
      Print #1 , "-> Bind DOS Filesystem -> ";
      If Btemp1 = 0 Then
         Sd_card_ok = 1
         Print #1 , "Status OK"
      Else
         Print #1 , "failed (" ; Btemp1 ; ")"
      End If
    Else
       Print #1 , "failed: " ;
       Select Case Gbdriveerror
          Case &HE0 : Print #1 , "Error drive not present"
          Case &HE1 : Print #1 , "Error drive not supported"
          Case &HE2 : Print #1 , "Error drive not initialized"
          Case &HE6 : Print #1 , "Error drive cmd not accepted"
          Case &HE7 : Print #1 , "Error drive no data"
          Case &HE9 : Print #1 , "Error drive init1"
          Case &HEA : Print #1 , "Error drive init2"
          Case &HEB : Print #1 , "Error drive init3"
          Case &HEC : Print #1 , "Error drive init4"
          Case &HED : Print #1 , "Error drive init5"
          Case &HEE : Print #1 , "Error drive init6"

          Case &HF1 : Print #1 , "Error drive read1"
          Case &HF2 : Print #1 , "Error drive read2"

          Case &HF5 : Print #1 , "Error drive write1"
          Case &HF6 : Print #1 , "Error drive write2"
          Case &HF7 : Print #1 , "Error drive write3"
          Case &HF8 : Print #1 , "Error drive write4"
       End Select
    End If
End Sub