'*******************************************************************************
'
'  Copyright Michael Koecher aka six1 8/2010
'  -> http://www.six1.net/   michael@koecher-web.de
'
'   http://creativecommons.org/licenses/by-sa/3.0/de/
'
'   Sie drfen:
'
'     * das Werk bzw. den Inhalt vervielfltigen, verbreiten und ffentlich zugnglich machen
'
'     * Abwandlungen und Bearbeitungen des Werkes bzw. Inhaltes anfertigen
'
'   Zu Den Folgenden Bedingungen:
'
'     * Namensnennung.
'       Sie mssen den Namen des Autors/Rechteinhabers in der von ihm festgelegten Weise nennen.
'
'     * Keine kommerzielle Nutzung.
'       Dieses Werk darf nicht fr kommerzielle Zwecke verwendet werden.
'
'     * Weitergabe unter gleichen Bedingungen.
'       Wenn Sie das lizenzierte Werk bzw. den lizenzierten Inhalt bearbeiten
'       oder in anderer Weise erkennbar als Grundlage fr eigenes Schaffen verwenden,
'       drfen Sie die daraufhin neu entstandenen Werke bzw. Inhalte nur
'       unter Verwendung von Lizenzbedingungen weitergeben, die mit denen
'       dieses Lizenzvertrages identisch oder vergleichbar sind.
'
'   Wobei gilt:
'
'     * Verzichtserklrung
'       Jede der vorgenannten Bedingungen kann aufgehoben werden, sofern Sie
'       die ausdrckliche Einwilligung des Rechteinhabers dazu erhalten.
'
'     * Sonstige Rechte
'       Die Lizenz hat keinerlei Einfluss auf die folgenden Rechte:
'          - Die gesetzlichen Schranken des Urheberrechts und sonstigen
'            Befugnisse zur privaten Nutzung
'          - Das Urheberpersnlichkeitsrecht des Rechteinhabers
'          - Rechte anderer Personen, entweder am Lizenzgegenstand selber oder
'            bezglich seiner Verwendung, zum Beispiel Persnlichkeitsrechte abgebildeter Personen.
'
'  Hinweis
'
'      Im Falle einer Verbreitung mssen Sie anderen alle Lizenzbedingungen
'      mitteilen, die fr dieses Werk gelten. Am einfachsten ist es,
'      einen Link auf http://creativecommons.org/licenses/by-sa/3.0/de/ einzubinden.
'

'*******************************************************************************
$nocompile


'-------------------------------------------------------------------------------
' ROUTINES
'-------------------------------------------------------------------------------

Sub Send_email(byval Socket_number As Byte)
    local Rx_size as word
    If Email_smtp <> "" Then
      Smtp_flag = 1
      Smtp_timeout = 0
      Call Socket_close(socket_number)
      If Dns_resolve_url(socket_number , Email_smtp) > 0 Then
         Smtp_timeout = 0
         Smtp_stage = 1
         Call Send_email_stage_one(smtp_sock)
         Reset Watchdog
         Do
           Incr Smtp_timeout
           Rx_size = Get_rx_size(socket_number)
           If Rx_size > 0 Then
              Reset Watchdog
              Call Send_email_stage_two(socket_number)
           End If
           Waitms 1
         Loop Until Smtp_timeout >= 1000 Or Smtp_stage = 8
         Smtp_flag = 0
      Else
         Print #1 , "SMTP: No DNS!"
      End If
    End If
End Sub

'-------------------------------------------------------------------------------
' Smtp_get_timestamp give back Timestamp
'-------------------------------------------------------------------------------
Function Smtp_get_timestamp() As String
     Local S_s As String * 25
     Local B_b As Byte
     B_b = Dayofweek()
     S_s = Lookupstr(b_b , Get_day_str) + " "
     S_s = S_s + Str(_day) + " "
     S_s = S_s + Lookupstr(_month , Get_month_str) + " "
     S_s = S_s + "20" + Str(_year) + " "
     S_s = S_s + Time$ + " "
     Smtp_get_timestamp = S_s + " +0200"
End Function


Sub Send_email_stage_one(byval Socket_number As Byte)
    ' DNS Resolve was ok, lets contact mailprovider
     #if Smtp_debug = 1
       Print #1 , "----"
       Print #1 , "Smtp_stage          : Connect to SMTP"
     #endif

      Call Socket_close(socket_number)

      Smtp_port_remote = 10000
      Smtp_port_remote = Smtp_port_remote + Rnd(55000)

      Call Socket_open(socket_number , Sn_mr_tcp , Smtp_port_remote , Smtp_port_local , Dns_resolved_ip(1) , 3)
End Sub


Sub Send_email_stage_two(byval Socket_number As Byte)
   Local Payload_pointer As Word
   Local S_s As String * 80
   Local B_b As Byte

    #if Smtp_debug = 1
         S_s = ""
         B_b = 1
         Do
           If Tcp_msg(b_b) >= 30 Then
              S_s = S_s + Chr(tcp_msg(b_b))
           End If
           Incr B_b
         Loop Until B_b = 100 Or B_b = Tcp_paket_size
         Print #1 , "Result from Provider: " ; S_s
         Print #1 , "Next Smtp_stage     : " ; Str(smtp_stage)
         Print #1 , "----"
       ' Call Http_dump_buffer(1 , Tcp_paket_size)
       ' Call Http_dump_buffer(2 , Tcp_paket_size)
    #endif

  Smtp_flag = 4

  Payload_pointer = 1

  Select Case Smtp_stage
    Case 1:
      S_s = "HELO WIZWEB200{013}{010}"
        Call Tcp_append_to_dataload(payload_pointer , S_s )
    Case 2:
      S_s = "AUTH LOGIN{013}{010}"
        Call Tcp_append_to_dataload(payload_pointer , S_s )
      S_s = Base64enc(email_address)
        Call Tcp_append_to_dataload(payload_pointer , S_s )
      S_s = "{013}{010}"
        Call Tcp_append_to_dataload(payload_pointer , S_s )
      S_s = Base64enc(email_pass)
        Call Tcp_append_to_dataload(payload_pointer , S_s )
      S_s = "{013}{010}"
        Call Tcp_append_to_dataload(payload_pointer , S_s )
    Case 3:
      S_s = "Mail From: " + Email_address + "{013}{010}"
        Call Tcp_append_to_dataload(payload_pointer , S_s )
    Case 4:
      S_s = "RCPT TO: " + Email_recipient + "{013}{010}"
        Call Tcp_append_to_dataload(payload_pointer , S_s )
    Case 5:
      S_s = "DATA{013}{010}"
        Call Tcp_append_to_dataload(payload_pointer , S_s )
    Case 6:
      S_s = "From: " + Email_address + "{013}{010}"
        Call Tcp_append_to_dataload(payload_pointer , S_s )
      S_s = "To: " + Email_recipient + "{013}{010}"
        Call Tcp_append_to_dataload(payload_pointer , S_s )
      S_s = "Subject: Automail from WIZ200WEB{013}{010}"
        Call Tcp_append_to_dataload(payload_pointer , S_s )
      S_s = "Date: " + Smtp_get_timestamp() + "{013}{010}"
        Call Tcp_append_to_dataload(payload_pointer , S_s )
      S_s = "{013}{010}"
        Call Tcp_append_to_dataload(payload_pointer , S_s )

      '*** MESSAGE ***
      S_s = "WIZNET200 SMTP is working!{013}{010}"
        Call Tcp_append_to_dataload(payload_pointer , S_s )
      S_s = "V"
        Call Tcp_append_to_dataload(payload_pointer , S_s )
      S_s = Version(2)
        Call Tcp_append_to_dataload(payload_pointer , S_s )
      S_s = "{013}{010}"
        Call Tcp_append_to_dataload(payload_pointer , S_s )
      S_s = "{013}{010}"
        Call Tcp_append_to_dataload(payload_pointer , S_s )
      S_s = "best Michael{013}{010}"
        Call Tcp_append_to_dataload(payload_pointer , S_s )
      S_s = "/ __)(_  _)( \/ )/  ){013}{010}"
        Call Tcp_append_to_dataload(payload_pointer , S_s )
      S_s = "\__ \ _)(_  )  (  )({013}{010}"
        Call Tcp_append_to_dataload(payload_pointer , S_s )
      S_s = "(___/(____)(_/\_)(__){013}{010}"
        Call Tcp_append_to_dataload(payload_pointer , S_s )
      '*** MESSAGE ***

      S_s = "{013}{010}.{013}{010}"
        Call Tcp_append_to_dataload(payload_pointer , S_s )
    Case 7:
      S_s = "QUIT{013}{010}"
        Call Tcp_append_to_dataload(payload_pointer , S_s )
   End Select


   Incr Smtp_stage
   Decr Payload_pointer
   If Payload_pointer > 1 Then
      ' copy buf into tx fifo
      Call Tcp_write_databuf(socket_number , Payload_pointer)
      ' updata txbuf pointer, send data
      Call Wiz_write_socket(socket_number , W5300_s0_cr1 , Sn_cr_send)
      Call Wiz_wait_tx(socket_number)
   End If
End Sub