'*******************************************************************************
'
'  Copyright Michael Koecher aka six1 8/2010
'  -> http://www.six1.net/   michael@koecher-web.de
'
'   http://creativecommons.org/licenses/by-sa/3.0/de/
'
'   Sie drfen:
'
'     * das Werk bzw. den Inhalt vervielfltigen, verbreiten und ffentlich zugnglich machen
'
'     * Abwandlungen und Bearbeitungen des Werkes bzw. Inhaltes anfertigen
'
'   Zu Den Folgenden Bedingungen:
'
'     * Namensnennung.
'       Sie mssen den Namen des Autors/Rechteinhabers in der von ihm festgelegten Weise nennen.
'
'     * Keine kommerzielle Nutzung.
'       Dieses Werk darf nicht fr kommerzielle Zwecke verwendet werden.
'
'     * Weitergabe unter gleichen Bedingungen.
'       Wenn Sie das lizenzierte Werk bzw. den lizenzierten Inhalt bearbeiten
'       oder in anderer Weise erkennbar als Grundlage fr eigenes Schaffen verwenden,
'       drfen Sie die daraufhin neu entstandenen Werke bzw. Inhalte nur
'       unter Verwendung von Lizenzbedingungen weitergeben, die mit denen
'       dieses Lizenzvertrages identisch oder vergleichbar sind.
'
'   Wobei gilt:
'
'     * Verzichtserklrung
'       Jede der vorgenannten Bedingungen kann aufgehoben werden, sofern Sie
'       die ausdrckliche Einwilligung des Rechteinhabers dazu erhalten.
'
'     * Sonstige Rechte
'       Die Lizenz hat keinerlei Einfluss auf die folgenden Rechte:
'          - Die gesetzlichen Schranken des Urheberrechts und sonstigen
'            Befugnisse zur privaten Nutzung
'          - Das Urheberpersnlichkeitsrecht des Rechteinhabers
'          - Rechte anderer Personen, entweder am Lizenzgegenstand selber oder
'            bezglich seiner Verwendung, zum Beispiel Persnlichkeitsrechte abgebildeter Personen.
'
'  Hinweis
'
'      Im Falle einer Verbreitung mssen Sie anderen alle Lizenzbedingungen
'      mitteilen, die fr dieses Werk gelten. Am einfachsten ist es,
'      einen Link auf http://creativecommons.org/licenses/by-sa/3.0/de/ einzubinden.
'

'*******************************************************************************
$nocompile

'-------------------------------------------------------------------------------
' Wiz_tcp Switch Function According To The Port
'-------------------------------------------------------------------------------
Sub Wiz_tcp(byval Socket_number As Byte)
   Local Y As Word , Data_len As Word , Pos As Word , Dummy_b As Byte , Dec_a As Word , Dec_b As Word

   Tcp_port_src_h = Wiz_read_socket(socket_number , W5300_s0_portr0)
   Tcp_port_src_l = Wiz_read_socket(socket_number , W5300_s0_portr1)
   Tcp_port_dst_h = Wiz_read_socket(socket_number , W5300_s0_dportr0)
   Tcp_port_dst_l = Wiz_read_socket(socket_number , W5300_s0_dportr1)

   #if Sn_mr0_align = 0
     Adres16_h = Wiz_read_socket(socket_number , W5300_s0_rx_fifor0)
     Adres16_l = Wiz_read_socket(socket_number , W5300_s0_rx_fifor1)
   #else
     Adres16_h = Wiz_read_socket(socket_number , W5300_s0_rx_rsr2)
     Adres16_l = Wiz_read_socket(socket_number , W5300_s0_rx_rsr3)
   #endif
   Data_len = Adres16
   Tcp_paket_size = Data_len
   Http_data_len = Data_len
   If Data_len.0 = 1 Then Incr Data_len

   'start reading data
   Pos = 1
   For Pos = 1 To Data_len Step 2
        Tcp_msg(pos) = Wiz_read_socket(socket_number , W5300_s0_rx_fifor0)
        Tcp_msg(pos + 1) = Wiz_read_socket(socket_number , W5300_s0_rx_fifor1)
   Next
   Call Wiz_write_socket(socket_number , W5300_s0_ir1 , &HFF )
   Call Wiz_write_socket(socket_number , W5300_s0_cr1 , Sn_cr_recv)

   #if Tcp_debug > 0
      Print #1 , "TCP RX-> length  : " ; Tcp_paket_size
      Print #1 , "TCP RX-> Dst Port: " ; Tcp_port_dst
      Print #1 , "TCP RX-> Src Port: " ; Tcp_port_src
'      Call Http_dump_buffer(3 , Tcp_paket_size)
   #endif
   If Tcp_paket_size > 0 Then
    Select Case Tcp_port_src
      Case Tcp_port_http : Call Http_parse(socket_number)
      Case Else :
         Print #1 , "Unknown TCP Port: " ; Tcp_port_src
    End Select
   End If
End Sub


'-------------------------------------------------------------------------------
' TCP_write_databuf write data to w5300 fifo
'-------------------------------------------------------------------------------
Sub Tcp_write_databuf(byval Socket_number As Byte , Byval Data_len As Word)
   Local Max_buffer_size As Word
   Local D As Word
   Local Add_address As Word , Address As Word
   Local Fifo0_addr As Word
   Local Fifo1_addr As Word

   'calculate Socket Address
   Add_address = Socket_number
   Decr Add_address
   Add_address = Add_address * Socket_reg_size
   Fifo0_addr = Add_address + W5300_s0_tx_fifor0
   Fifo1_addr = Add_address + W5300_s0_tx_fifor1
   Max_buffer_size = Get_tx_size(socket_number)
   If Data_len > Max_buffer_size Then
      Data_len = Max_buffer_size
   End If
   Adres16 = Data_len
   If Data_len.0 = 1 Then Incr Data_len
   For D = 1 To Data_len Step 2
     Out Fifo0_addr , Tcp_msg(d)                            'High adress
     Out Fifo1_addr , Tcp_msg(d + 1)                        'low  adress
   Next
   ' Set Write Size Register
   Call Wiz_write_socket(socket_number , W5300_s0_tx_wrsr0 , &H0)
   Call Wiz_write_socket(socket_number , W5300_s0_tx_wrsr1 , &H0)
   Call Wiz_write_socket(socket_number , W5300_s0_tx_wrsr2 , Adres16_h)
   Call Wiz_write_socket(socket_number , W5300_s0_tx_wrsr3 , Adres16_l)
End Sub


'-------------------------------------------------------------------------------
' TCP_Append_to_dataload  transfer bytes to tx buffer
'-------------------------------------------------------------------------------
Sub Tcp_append_to_dataload(byref Dataload_pointer As Word , Byval S_s As String )
   Local Load_size As Word
   Load_size = Len(s_s)
   If Load_size > 0 Then
     Load_size = Memcopy(s_s , W5300_payload_byte(dataload_pointer) , Load_size)
     Dataload_pointer = Dataload_pointer + Load_size
   End If
'(
 Dim W1 As Word , W2 As Word , W3 As Word
 Local Str_len As Byte
 Local Char_byte As String * 1
 Local B_b As Byte
   Str_len = Len(s_s)
   For B_b = 1 To Str_len
      Char_byte = Mid(s_s , B_b , 1)
      W5300_payload_byte(dataload_pointer) = Char_byte
      Incr Dataload_pointer
   Next
')
End Sub